<h3 align="center">
  Headless UI
</h3>

<p align="center">
  A set of completely unstyled, fully accessible UI components, designed to integrate
  beautifully with Tailwind CSS.
</p>

---

## Documentation

For full documentation, visit [headlessui.dev](https://headlessui.dev).

### Installing the latest version

You can install the latest version by using:

- `npm install @headlessui/react@latest`.
- `npm install @headlessui/vue@latest`.

### Installing the insiders version

You can install the insiders version (which points to whatever the latest commit on the `main` branch is) by using:

- `npm install @headlessui/react@insiders`.
- `npm install @headlessui/vue@insiders`.

**Note:** The insiders build doesn't follow semver and therefore doesn't guarantee that the APIs will be the same once they are released.

## Packages

| Name                                                                                                     |                                                        Version                                                        |                                                        Downloads                                                         |
| :------------------------------------------------------------------------------------------------------- | :-------------------------------------------------------------------------------------------------------------------: | :----------------------------------------------------------------------------------------------------------------------: |
| [`@headlessui/react`](https://github.com/tailwindlabs/headlessui/tree/main/packages/%40headlessui-react) | [![npm version](https://img.shields.io/npm/v/@headlessui/react.svg)](https://www.npmjs.com/package/@headlessui/react) | [![npm downloads](https://img.shields.io/npm/dt/@headlessui/react.svg)](https://www.npmjs.com/package/@headlessui/react) |
| [`@headlessui/vue`](https://github.com/tailwindlabs/headlessui/tree/main/packages/%40headlessui-vue)     |   [![npm version](https://img.shields.io/npm/v/@headlessui/vue.svg)](https://www.npmjs.com/package/@headlessui/vue)   |   [![npm downloads](https://img.shields.io/npm/dt/@headlessui/vue.svg)](https://www.npmjs.com/package/@headlessui/vue)   |

## Community

For help, discussion about best practices, or any other conversation that would benefit from being searchable:

[Discuss Headless UI on GitHub](https://github.com/tailwindlabs/headlessui/discussions)

For casual chit-chat with others using the library:

[Join the Tailwind CSS Discord Server](https://discord.gg/7NF8GNe)

## Contributing

If you're interested in contributing to Headless UI, please read our [contributing docs](https://github.com/tailwindlabs/headlessui/blob/main/.github/CONTRIBUTING.md) **before submitting a pull request**.
